#coding: utf-8
import hashlib
import json
import threading
import time

import pymysql as pymysql
import requests


class BindUser():
    def __init__(self):
        self.SSL_VERIFY = True
        self.mobile = 13300015000                            # 将要累加的手机号    (累加方式)
        self.carId = 202006115001                            # 将要累加得车机     （累加方式）
        self.mobileArr = ["13245670010","13245670011","13245670012"]                     # 将要累加的手机号   （数组方式）
        self.carIdArr = ["202003060165","202003060166","202003060167"]                     # 将要累加得车机号   （数组方式）
        self.count = 5000                                       # 累加次数
        self.sn = 123                                        # 车机SN码
        self.inviteCode = "123456"                               #绿卡邀请码
        self.pad = 0                                       #车牌号累加起始
        self.db = None

        self.dbhost = "10.100.5.3"
        self.dbuser = "root"
        self.dbpassword = "root"
        self.database = "appserver"
        self.dbport = 13306

    ##############################################
    # 获取短信验证码
    ##############################################
    def getMsgCode(self,mobile):
        url = "http://api-test.vandyo.com/user/authorize/authcode/get"
        ts = int(time.time())
        headers = {"Accept-Encoding": "gzip", "Content-Type": "application/json; charset=UTF-8"}
        params = {}
        params["reqtype"] = 1
        params["ts"] = ts
        params["mobile"] = mobile
        cs = self.getSignature(params)
        params["cs"] = cs
        resObj = requests.get(url, headers=headers, params=params, verify=self.SSL_VERIFY)
        print("\n请求地址：" + url)
        print("-------------------------返回结果：-------------------------")
        print(resObj.text)

    ##############################################
    # 使用短信验证码登录
    ##############################################
    def loginByMsgCode(self,mobile,msgCode):
        url = "http://api-test.vandyo.com/user/authorize/authcode/login"
        ts = int(time.time())
        headers = {"Accept-Encoding": "gzip", "Content-Type": "application/json; charset=UTF-8"}
        params = {}
        params["ts"] = ts
        postData = {}
        postData["mobile"] = mobile
        postData["verify"] = msgCode
        resObj = requests.post(url, headers=headers, params=params, data=json.dumps(postData), verify=self.SSL_VERIFY)
        print("\n请求地址：" + url)
        print("-------------------------返回结果：-------------------------")
        print(resObj.text)
        resObj = json.loads(resObj.text)
        uData = {}
        uData["sid"] = resObj["result"]["sid"]
        uData["uid"] = resObj["result"]["uid"]
        return uData

    ##############################################
    # 绑定车机
    ##############################################
    def bindCar(self,uid,sid,din):
        url = "http://api-test.vandyo.com/car/car_add"
        ts = int(time.time())
        headers = {"Accept-Encoding": "gzip", "Content-Type": "application/json; charset=UTF-8"}
        params = {}
        params["ts"] = ts
        params["sid"] = sid
        params["uid"] = uid
        postData = {}
        postData["din"] = din
        postData["dsn"] = self.sn
        postData["gasno"] = "95"
        postData["mmile"] = ""
        postData["plate"] = "渝Z" + str(10000 + self.pad)
        self.pad = self.pad + 1
        postData["tid"] = "129577"
        cs = self.getSignature(params, json.dumps(postData))
        params["cs"] = cs
        params.pop("sid")
        resObj = requests.post(url, headers=headers, params=params, data=json.dumps(postData), verify=self.SSL_VERIFY)
        print("\n请求地址：" + url)
        print("-------------------------返回结果：-------------------------")
        print(resObj.text)

    ##############################################
    # 绑定绿卡
    ##############################################
    def bindGreenCard(self,uid,sid):
        url = "http://api-test.vandyo.com/extenduser/card/activate"
        ts = int(time.time())
        headers = {"Accept-Encoding": "gzip", "Content-Type": "application/json; charset=UTF-8"}
        params = {}
        params["ts"] = ts
        params["sid"] = sid
        params["uid"] = uid
        postData = {}
        postData["area"] = "重庆市"
        postData["convertCode"] = ""
        postData["inviteCode"] = self.inviteCode
        postData["lat"] = 29.573062
        postData["lng"] = 106.59255
        postData["type"] = 1
        cs = self.getSignature(params, json.dumps(postData))
        params["cs"] = cs
        params.pop("sid")
        resObj = requests.post(url, headers=headers, params=params, data=json.dumps(postData), verify=self.SSL_VERIFY)
        print("\n请求地址：" + url)
        print("-------------------------返回结果：-------------------------")
        print(resObj.text)

    #################################################
    # 获取一个Md5的字符串
    #################################################
    def getMd5String(self,data):
        m = hashlib.md5()
        b = data.encode(encoding='utf-8')
        m.update(b)
        str_md5 = m.hexdigest()
        return str_md5

    #################################################
    # 获取签名，传入一个map,
    # （需要对传入的参数，按照key的升序排列）
    #################################################
    def getSignature(self,data,postData={}):
        sMd5 = ""
        if len(postData) == 0:
            keys = sorted(data.keys())
            s = ""
            for key in keys:
                s = s + key + "[" + str(data[key]) + "];"
            sMd5 = self.getMd5String(s)
        else:
            data["Data"] = postData
            keys = sorted(data.keys())
            s = ""
            for key in keys:
                s = s + key + "[" + str(data[key]) + "];"
            sMd5 = self.getMd5String(s)
        return sMd5

    #################################################
    # 连接数据库
    #################################################
    def dbConnect(self):
        self.db = pymysql.connect(host=self.dbhost, user=self.dbuser, password=self.dbpassword, database=self.database, port=self.dbport)
    #################################################
    # 关闭数据库
    #################################################
    def dbClose(self):
        self.db.close()
    #################################################
    # 查询最新的验证码
    #################################################
    def getMsgCodeSql(self,mobile):
        self.db = pymysql.connect(host=self.dbhost, user=self.dbuser, password=self.dbpassword, database=self.database,
                                  port=self.dbport)
        sql = 'select code from t_app_verify_mobile t where t.mobile=' + mobile + ' and t.status=1 order by t.insert_time desc'
        cursor = self.db.cursor()
        cursor.execute(sql)
        self.db.close()
        cursor.close()
        res = cursor.fetchone()
        code = res[0]
        return code

    #################################################
    # 绑定车流程
    #################################################
    def doBindCar(self,mobile,din):
        self.getMsgCode(mobile)
        time.sleep(0.5)
        msgCode = self.getMsgCodeSql(mobile)
        loginInfo = self.loginByMsgCode(mobile,msgCode)
        self.bindCar(loginInfo["uid"],loginInfo["sid"],din)
        self.bindGreenCard(loginInfo["uid"],loginInfo["sid"])


    #################################################
    # 绑定多个车流程(累加方式)
    #################################################
    def doBindMultCar(self):
        for i in range(0,self.count):
            mobile = str(self.mobile + i)
            carId = "M" + str(self.carId + i)
            theThread = threading.Thread(target=self.doBindCar, args=(mobile, carId,))
            theThread.start()
            time.sleep(0.1)

    #################################################
    # 绑定多个车流程(数组方式)
    #################################################
    def doBindMultCarArr(self):
        for i in range(0,len(self.mobileArr)):
            mobile = self.mobileArr[i]
            carId = "M" + str(self.carIdArr[i])
            theThread = threading.Thread(target=self.doBindCar, args=(mobile, carId,))
            theThread.start()


if __name__ == "__main__":
    # BindUser().getMsgCode("1245670001")
    # print(BindUser().loginByMsgCode("13245670001","141743"))
    # BindUser().bindCar("c927f5598d984b08ba51a3facd9ce3ce","87401ea4a78144639cde8cf47ccb1da0")
    # obj = BindUser()
    # obj.dbConnect()
    # res = obj.getMsgCodeSql("13245670001")
    # print(res)
    # obj.dbClose()

    obj = BindUser()
    # obj.dbConnect()
    obj.doBindMultCar()

    # obj = BindUser()
    # obj.dbConnect()
    # obj.doBindMultCarArr()